/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Günter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Günter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

de.ggbs.abs.gImapFolder=null;  //nsIRDFResource, nsIMsgFolder
de.ggbs.abs.gAccount=null;
de.ggbs.abs.gIdty=null;
de.ggbs.abs.gMessenger=null;

de.ggbs.abs.gFakeDraft=true;        // with SendMsg, if true: fake the draft folder (else use real draft folder and move)
                                    //should probably be a preference
de.ggbs.abs.gSavedDraftFolder=null; // the save original drafts folder

de.ggbs.abs.imapSaveDone=function() {
dump('upload cleanUp\n');
  if (de.ggbs.abs.gABS.imapusedraft && de.ggbs.abs.gFakeDraft && de.ggbs.abs.gSavedDraftFolder) {
    de.ggbs.abs.gIdty.draftFolder=de.ggbs.abs.gSavedDraftFolder;
    de.ggbs.abs.gSavedDraftFolder=null;
  }
  if (de.ggbs.abs.gABS.count>0) {
    de.ggbs.abs.statustxt('+', 1, false,'compacting..');
    if (de.ggbs.abs.gABS.usesPopup && !de.ggbs.abs.gABS.exiting) setTimeout(de.ggbs.abs.compact, 1000);  // really needed :-( but not at exit!!
    else de.ggbs.abs.compact();
  } else {
    de.ggbs.abs.statustxt('+', 3, false, 'compacting..'+de.ggbs.abs.gStrings.getString('skipped'));
    de.ggbs.abs.uploadDone(); //TODO: what, if compacting delayed??
  }
}
de.ggbs.abs.imapLoadDone=function() {
  de.ggbs.abs.downloadDone();
}
de.ggbs.abs.compact=function() {
  try { // could throw exception in case, server not reacheable
    de.ggbs.abs.gImapFolder.compact(null, null);  // only needed on upload
  } catch(e) { }
//  de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('ok'), 2, false);
  de.ggbs.abs.statustxt('ok', 2, false);
dump('compacting done\n');
  de.ggbs.abs.uploadDone();
}

de.ggbs.abs.connect=function() {
  Components.utils.import("resource:///modules/MailUtils.js");
  de.ggbs.abs.gImapFolder=MailUtils.getFolderForURI(de.ggbs.abs.gABS.imapfolder, true);
  if (!de.ggbs.abs.gImapFolder) {
dump("ABS: no folder found for "+de.ggbs.abs.gABS.imapfolder+"\n");
    de.ggbs.abs.statustxt(de.ggbs.abs.errorstr(-3), 2, true);
    de.ggbs.abs.gAbort=2;
    de.ggbs.abs.killMe();
    return false;
  }

  // be sure we have logged on to the server
  var windowsEnum = Services.wm.getEnumerator("mail:3pane");  //.getMostRecentWindow("mail:3pane")
  var w=windowsEnum.getNext();
  if (w)
    de.ggbs.abs.gImapFolder.updateFolder(w.msgWindow);   //the msgWindow is essential!!
  else
    dump('IMAP connect: no msgWindow\n');
    //with no msgWindow, we cannot connect, but thats ok if we had connected earlier
    //      otherwise may throw 'Access denied' error on upload
    //      or 'No message found' on download
  return true;
}


///////////////////////////////////////////////////////////////////////
//  Save mab files to imap folder

de.ggbs.abs.imapSave=function(syncedBooks) {
  if (!de.ggbs.abs.connect()) return;

  var server=de.ggbs.abs.gImapFolder.server;
  var gAccountManager = MailServices.accounts;
  de.ggbs.abs.gAccount=gAccountManager.FindAccountForServer(server);
  de.ggbs.abs.gIdty=de.ggbs.abs.gAccount.defaultIdentity;

  if (de.ggbs.abs.gABS.imapusedraft) {
    if (de.ggbs.abs.gFakeDraft) {
      // createMessage saves to the 'Draft' Folder of the given identity
      // temporary switch the Drafts-Folder to the to be used folder
      de.ggbs.abs.gSavedDraftFolder=de.ggbs.abs.gIdty.draftFolder;
      de.ggbs.abs.gIdty.draftFolder=de.ggbs.abs.gABS.imapfolder;
    }
    de.ggbs.abs.gTempName='';
  } else {
    de.ggbs.abs.gTempName='absmail.eml';
  }
  de.ggbs.abs.cleanUp=de.ggbs.abs.imapSaveDone; // register cleanup function

  //be sure, headers are read or else, delete of old messages will not work
  // calls imapSaveStage2 when finished
  de.ggbs.abs.statustxt('+',1,false,de.ggbs.abs.gStrings.getString('loadimap')+'..');
  if (!de.ggbs.abs.gABS.exiting) de.ggbs.abs.loadHeaders(de.ggbs.abs.imapSaveStage2);
  else de.ggbs.abs.imapSaveStage2();  // loadHeaders works asynchron: bad when TB finishes with or without a popupwindow
  return;
}

de.ggbs.abs.imapSaveStage2=function () {
  de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('ok'),2,false);
  if (de.ggbs.abs.gAbort) { de.ggbs.abs.killMe(); return; }

  if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.imapSaveNextBook, 0);
  else de.ggbs.abs.imapSaveNextBook();
  return;
}

de.ggbs.abs.imapSaveNextBook=function() {
  if (!de.ggbs.abs.gMabs.Count() || de.ggbs.abs.gAbort) {
dump('upload finished\n');
    de.ggbs.abs.killMe(); // kill status popup
    return;
  }

  var dir=de.ggbs.abs.gMabs.GetElementAt(0).QueryInterface(Components.interfaces.nsIAbDirectory);
  de.ggbs.abs.gMabs.RemoveElement(dir);
  var mabName=dir.dirName;
  var mabFile=dir.fileName;

  var lmd = de.ggbs.abs.getLastModified(dir);
  var lmds='lastMod='+(lmd?de.ggbs.abs.timeString(lmd*1000):'before appstart');
  if (!de.ggbs.abs.gABS.forcedUploadOf(mabFile) &&
      !de.ggbs.abs.gForce && de.ggbs.abs.gABS.checkLastModTime && de.ggbs.abs.gABS.appstarttime>=lmd) {
    de.ggbs.abs.statustxt('- '+mabName+' '+de.ggbs.abs.gStrings.getString('skipped'), 3, false, null, lmds);
dump('upload '+mabName+' skipped ('+lmds+')\n');
    de.ggbs.abs.imapSaveNextBook();
    return;
  }
dump('upload '+mabName+' ('+lmds+')\n');

  var externalFilename=de.ggbs.abs.gABS.externalFilename(dir);
  externalFilename=externalFilename.replace(/\.ldif?$/i,'.mab');

  de.ggbs.abs.statustxt('- '+mabName+'.', 1, false, null, lmds);  // 1. dot: started

//  get old messages for this addressbook
  var deleteMsgs=Components.classes["@mozilla.org/supports-array;1"]
    .createInstance(Components.interfaces.nsISupportsArray);
  var msgId=de.ggbs.abs.getMsgId(externalFilename);
  var msgs=de.ggbs.abs.gImapFolder.messages;
  while (msgs.hasMoreElements()) {    //simpleEnumerator
    var msg=msgs.getNext();
    msg.QueryInterface(Components.interfaces.nsIMsgDBHdr);
    if (msg.messageId == msgId) {
      deleteMsgs.AppendElement(msg);
    }
  }

  if (de.ggbs.abs.gABS.imapusedraft)
    de.ggbs.abs.saveAsDraft(externalFilename, mabName, mabFile, deleteMsgs);
  else
    de.ggbs.abs.saveViaFile(externalFilename, mabName, mabFile, deleteMsgs);
  de.ggbs.abs.gABS.forceUploadOf(mabFile, false);
  de.ggbs.abs.gABS.count+=1;

  return;
}

/////////////////////////////////////////////////////////////////////////
//  Load mab files from imap folder


de.ggbs.abs.imapLoad=function() {
  if (!de.ggbs.abs.connect()) return;

  de.ggbs.abs.gTempName='abstemp.mab';
  de.ggbs.abs.cleanUp=de.ggbs.abs.imapLoadDone; // register cleanup function


  var server=de.ggbs.abs.gImapFolder.server;
  var gAccountManager = MailServices.accounts;
  de.ggbs.abs.gAccount=gAccountManager.FindAccountForServer(server);
  de.ggbs.abs.gIdty=de.ggbs.abs.gAccount.defaultIdentity;
  de.ggbs.abs.gMessenger = Components.classes['@mozilla.org/messenger;1'].createInstance().
    QueryInterface(Components.interfaces.nsIMessenger);

  de.ggbs.abs.statustxt('+',1,false,de.ggbs.abs.gStrings.getString('loadimap')+'..');

  de.ggbs.abs.loadHeaders(de.ggbs.abs.imapLoadStage2);
  return;
}

de.ggbs.abs.imapLoadStage2=function() {
  de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('ok'),2,false);
  if (de.ggbs.abs.gAbort) { de.ggbs.abs.killMe(); return; }

  if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.imapLoadNextBook, 0);
  else de.ggbs.abs.imapLoadNextBook();
  return;
}


de.ggbs.abs.imapLoadNextBook=function() {
  if (de.ggbs.abs.gAbort) { de.ggbs.abs.killMe(); return; }

  if (!de.ggbs.abs.gMabs.Count()) {
    de.ggbs.abs.killMe(); // kill status popup
    return;
  }
  var dir=de.ggbs.abs.gMabs.GetElementAt(0);
  de.ggbs.abs.gMabs.RemoveElement(dir)
  var externalFilename;
  var newSinglebook;
  if (dir instanceof Components.interfaces.nsIAbDirectory) {
    var mabName=dir.dirName;
    var mabFile=dir.fileName;

    if ((de.ggbs.abs.gForce || !de.ggbs.abs.gABS.checkLastModTime) && !de.ggbs.abs.askOverwrite(dir, false)) {
        de.ggbs.abs.statustxt('- '+mabName+" "+de.ggbs.abs.gStrings.getString('skipped'), 3, false);
        de.ggbs.abs.imapLoadNextBook();
        return;
    }

    externalFilename=de.ggbs.abs.gABS.externalFilename(dir);
    newSinglebook=false;
  } else {
    mabName = dir.QueryInterface(Components.interfaces.nsISupportsString).data;
    externalFilename = mabName+'.mab';
    mabFile = mabName.replace( /\W/g, "_" )+'.mab';
    newSinglebook=true;
dump('getImapData, new single book filename='+externalFilename+'\n');
  }
  de.ggbs.abs.statustxt('- '+mabName+'.', 1, false);  // 1. dot: start

  // find the correct message (looking for the messageId)
  var msgId = de.ggbs.abs.getMsgId(externalFilename);
  var msgs=de.ggbs.abs.gImapFolder.messages;
  var theMsg=null;
  var theMsgKey=0;
  while (msgs.hasMoreElements()) {
    var msg=msgs.getNext();
    msg.QueryInterface(Components.interfaces.nsIMsgDBHdr);
    // msg.messageKey are the id's as used by the imapserver
    // find the last corresponding message (but there should only be one)
    if (msg.messageId == msgId && msg.messageKey>theMsgKey) {
      theMsg=msg;
      theMsgKey=msg.messageKey;
    }
  }
  if (!theMsg) {
    de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('nomessage'), 2, newSinglebook);
    if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.imapLoadNextBook, 0);
    else de.ggbs.abs.imapLoadNextBook();
    return;
  }
  de.ggbs.abs.statustxt('.', 0, false); // 2. dot: message found

  var lms;
  if (!newSinglebook && !de.ggbs.abs.gForce && de.ggbs.abs.gABS.checkLastModTime) {
    var datestr=theMsg.ccList;
    if (datestr.substr(0,1)=='"' || datestr.substr(0,1)=="'") datestr=datestr.substr(1,datestr.length-2)
    var mlmt=new Date(datestr);
    var localMabFile = de.ggbs.abs.gABS.getDir('ProfD');
    localMabFile.appendRelativePath( mabFile );
    var flmt=new Date(localMabFile.lastModifiedTime);
    lms='lastMod mab: '+de.ggbs.abs.timeString(flmt)+' imap: '+de.ggbs.abs.timeString(mlmt);
    if (mlmt<=flmt) {
      de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('skipped'), 2, false, null, lms);
dump('download '+mabName+' skipped:\n  file-time='+flmt+'\n  msg-time='+mlmt+'\n');
dump('   file-time='+flmt.valueOf()+'  msg-time='+mlmt.valueOf()+'\n');
      de.ggbs.abs.imapLoadNextBook();
      return;
    } else if (!de.ggbs.abs.askOverwrite(dir, false)) {
      de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('skipped'), 2, false, null, 'Policy: '+de.ggbs.abs.gABS.downloadpolicy);
      de.ggbs.abs.imapLoadNextBook();
      return;
    }
  }
  de.ggbs.abs.statustxt('', 0, false, null, lms); // only output time messages

  var msgURI=de.ggbs.abs.gImapFolder.getUriForMsg(theMsg);
  var ms=de.ggbs.abs.gMessenger.messageServiceFromURI(msgURI);

  var streamListener = {
    body: '',
    mabName: null,
    mabFile: null,
    onDataAvailable: function(request, context, inputStream, offset, count){
      try {
        var sis=Components.classes["@mozilla.org/scriptableinputstream;1"].
          createInstance(Components.interfaces.nsIScriptableInputStream);
        sis.init(inputStream);
        this.body+=sis.read(count);
      } catch(ex) { alert(ex+'\noffset='+offset+' count='+count); }
    },
    onStartRequest: function(request, context) {
      this.body='';
    },
    onStopRequest: function(aRequest, aContext, aStatusCode) {
      if (!aStatusCode) {
        de.ggbs.abs.statustxt('.', 0, false); // 3. dot: message read
        // extract mab data from message
        var boundary=this.body.match(/boundary="(.*?)"/g);
        if (!boundary) {
          de.ggbs.abs.statustxt(' (encrypted) ', 0, false);
        } else if (boundary[1]) { //signed
          boundary=boundary[1].match(/boundary="(.*?)"/);
          boundary='--'+boundary[1];
        } else {                  //not signed
          boundary=boundary[0].match(/boundary="(.*?)"/);
          boundary='--'+boundary[1];
        }
        if (boundary) try {
          var ind=this.body.indexOf(boundary);     // start of text part
          if (ind<0) throw('noattachment');
          ind=this.body.indexOf(boundary, ind+1);  // start of mab part
          if (ind<0) throw('noattachment');
          var cte;
          var ci=this.body.indexOf('Content-Transfer-Encoding:', ind+1);
          if (ci>=0) {
            var cie=this.body.indexOf('\r', ci);
            if (cie<0) cie=this.body.indexOf('\n', ci);
            cte=this.body.substring(ci+27, cie);
          } else {
            cte='7bit';
          }
          var msgstart=this.body.indexOf('\n\n', ind+1);
          var sub;
          if (msgstart<0) {
            msgstart=this.body.indexOf('\r\n\r\n', ind+1);
            sub=2;
          } else
            sub=1;
          if (msgstart<0) throw('incompleteattachment');
          var msgend=this.body.indexOf(boundary, msgstart+2*sub);
          if (msgend<0) throw('incompleteattachment');
          var msg=this.body.substring(msgstart+2*sub,msgend-sub);
          if (cte=='base64')
            try {
              msg=msg.replace(/[\r\n]/gm,'');
              msg=atob(msg);
            } catch(e) { alert('base64: '+e); throw('incompleteattachment'); }
/*oldtest
          if (msg.substr(0,7)=='// <!--' ||      // mab file
              msg.substr(0,7)=='dn: cn=') {      // ldif file
*/
	          // write file to temporary file
	          var nsITmpFile=de.ggbs.abs.gABS.getDir('TmpD');
	          nsITmpFile.appendRelativePath(de.ggbs.abs.gTempName);
dump('abs: imap: write tempfile: '+nsITmpFile.path+'\n');
            if (de.ggbs.abs.gABS.writeMabData(nsITmpFile, msg)) {
  	          de.ggbs.abs.statustxt('.', 0, false); // 4. dot: temp file created
              if (msg.substr(0,7)=='// <!--') {
            	  try {
      	          // replace addressbook data
      	          var ret;
      	          if ((ret=de.ggbs.abs.replaceAddressBook(this.mabName, this.mabFile, nsITmpFile)))
      	            de.ggbs.abs.statustxt(ret, 2, true);
      	          else {
      	            de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('copied'), 2, false);
//###                    if (newSinglebook) de.ggbs.abs.abs_init(); // insert in options list
      	            de.ggbs.abs.gABS.count+=1;
      	          }
            	  } catch (e) {alert('imap replaceaddressbook: '+e); }
              } else {  // LDIF
                var dir=de.ggbs.abs.gABS.getAddressBook(this.mabFile);  //dir=nsIAbDirectory
                if (!dir)
                  de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied'), 2, true, null, 'Dir not found');
                else {
                  var ret=de.ggbs.abs.gABS.clearAddressBook(dir);
                  if (ret)
                    de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied'), 2, true, null, ret);
                  else {
                    var observerService=Services.obs;
                    de.ggbs.abs.LDIFloaded.dir=dir;
                    de.ggbs.abs.LDIFloaded.lms='';
                    de.ggbs.abs.LDIFloaded.os=observerService;
                    de.ggbs.abs.LDIFloaded.type='imap';
                    observerService.addObserver(de.ggbs.abs.LDIFloaded,"LDIFcomplete",false);
                    de.ggbs.abs.gABS.LDIFAddressBook(dir, nsITmpFile);
                    //loading LDIF is ASYNCHRONOUS!
                    return; //do not break!
                  }
                }
              }
            } else {
              de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied')+' (?)', 2, true); //Bad Status
            }
/*oldtest
          } else {  //partly copied
            if (cte=='7bit')
              de.ggbs.abs.statustxt('attachment not a mab file', 2, true);
            else
              de.ggbs.abs.statustxt('unknown encoding '+cte, 2, true);
          }
*/
        } catch(e) {de.ggbs.abs.statustxt(e, 2, true);}
        else
          de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('noattachment'), 2, true);
      } else
        de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied')+' ('+aStatusCode+')', 2, true); //Bad Status
      if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.imapLoadNextBook, 0);
      else de.ggbs.abs.imapLoadNextBook();
    } //OnStopRequest
  };  //streamListener

  streamListener.mabName=mabName;
  streamListener.mabFile=mabFile;
	var aurl = new Object();
	ms.CopyMessage(msgURI, streamListener, false, null, null, aurl);

  return;
}

/////////////////////////////////////////////////////////////////////////

// from messageWindow@48
// wait till all headers are read for the imap folder
de.ggbs.abs.loadHeaders=function(callback) {
  var syncListener = {
    callback: null,
    mailSession : null,
    imapfolder: null,
    OnItemAdded: function(parentItem, item) {},
    OnItemRemoved: function(parentItem, item) {},
    OnItemPropertyChanged: function(item, property, oldValue, newValue) {},
    OnItemIntPropertyChanged: function(item, property, oldValue, newValue) {},
    OnItemBoolPropertyChanged: function(item, property, oldValue, newValue) {},
    OnItemUnicharPropertyChanged: function(item, property, oldValue, newValue){},
    OnItemPropertyFlagChanged: function(item, property, oldFlag, newFlag) {},
    OnItemEvent: function(folder, event) {
       var eventType = event.toString();

dump('load Headers listener '+eventType+'\n');
      if (eventType == "FolderLoaded") {
        if (folder) {
          var uri = folder.URI;
          if (uri == this.imapfolder) {
            this.mailSession.RemoveFolderListener(this);
            var msgFolder = folder.QueryInterface(Components.interfaces.nsIMsgFolder);
            if (msgFolder) {
              msgFolder.endFolderLoading();
              this.callback();
            }
          }
        }
      }
    }
  }
  // first be sure all header are available
  // when they are, the syncListener calls the next stage
dump('in loadHeaders\n');
  syncListener.callback=callback;
  syncListener.imapfolder=de.ggbs.abs.gABS.imapfolder;
  var nsIFolderListener = Components.interfaces.nsIFolderListener;
  var mailSession = MailServices.mailSession;
  syncListener.mailSession=mailSession;
  mailSession.AddFolderListener(syncListener, nsIFolderListener.event);
  de.ggbs.abs.gImapFolder.startFolderLoading();
  de.ggbs.abs.gImapFolder.updateFolder(null);
dump('in loadHeaders, waiting for listener\n');
  return;
}

///////////////////////////////////////////////////////////////////////
de.ggbs.abs.saveAsDraft=function(externalFilename, mabName, mabFile, deleteMsgs) {
  var stateListener = {
    msgCompose : null,
    QueryInterface: function(iid) {
dump('ABS: IMAP: ViaDraft: QueryInterface\n');
      if (iid.equals(Components.interfaces.nsIMsgComposeStateListener) ||
          iid.equals(Components.interfaces.nsISupports))
        return this;
      throw Components.results.NS_NOINTERFACE;
      return 0;
    },
    NotifyComposeFieldsReady: function() {  //not called
dump('ABS: IMAP: ViaDraft: NotifyComposeFieldsReady\n');
    },
    ComposeProcessDone: function(aResult) {
dump('ABS: IMAP: ViaDraft: ComposeProcessDone '+aResult+'\n');
      if (aResult) {
        this.msgCompose.UnregisterStateListener(this);
        de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied'), 2, true);
        if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.imapSaveNextBook, 0);
        else de.ggbs.abs.imapSaveNextBook();
      }
    },
    SaveInFolderDone: function(folderURI) {
dump('ABS: IMAP: ViaDraft: SaveInFolderDone\n');
      de.ggbs.abs.statustxt(".", 0, false); // 4. dot: upload ready
      this.msgCompose.UnregisterStateListener(this);
      de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('copied'), 2, false);
      if (deleteMsgs.Count()>0) {
        try {
          de.ggbs.abs.gImapFolder.deleteMessages ( deleteMsgs, null, true, false, null, false);
        } catch(e) { //SeaMonkey
          var dm=Components.classes["@mozilla.org/array;1"].
              createInstance(Components.interfaces.nsIMutableArray);
          for (var i=0; i<deleteMsgs.Count(); i++)
            dm.appendElement(deleteMsgs.GetElementAt(i), false);
          de.ggbs.abs.gImapFolder.deleteMessages ( dm, null, true, false, null, false);
        }
      }
      if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.imapSaveNextBook, 0);
      else de.ggbs.abs.imapSaveNextBook();
    }
  };

  var params = Components.classes["@mozilla.org/messengercompose/composeparams;1"]
    .createInstance(Components.interfaces.nsIMsgComposeParams);
  params.composeFields = Components.classes["@mozilla.org/messengercompose/composefields;1"]
    .createInstance(Components.interfaces.nsIMsgCompFields);
  params.composeFields.securityInfo = Components.classes["@mozilla.org/messenger-smime/composefields;1"]
    .createInstance(Components.interfaces.nsIMsgSMIMECompFields);

  //var encryptionPolicy = de.ggbs.abs.gIdty.getIntAttribute("encryptionpolicy");
  // 0 == never, 1 == if possible, 2 == always Encrypt.
  params.composeFields.securityInfo.requireEncryptMessage=false;
  params.composeFields.securityInfo.signMessage=false; //=de.ggbs.abs.gIdty.getBoolAttribute("sign_mail");

  params.identity = de.ggbs.abs.gIdty;
  //Set to PlainText or the info part ("Do not delete") is missing
  params.format = Components.interfaces.nsIMsgCompFormat.PlainText;
    //.PlainText or .HTML, .Draft, , .Template, .Default
  params.type=Components.interfaces.nsIMsgCompType.New;
    //.New (=default) or .NewsPost,.MailToUrl, .Template, .Reply u.a.

  var composeFields = params.composeFields;
  composeFields.QueryInterface( Components.interfaces.nsIMsgCompFields);
  composeFields.characterSet = 'UTF-8';
  composeFields.subject = 'Addressbooks Synchronizer: '+externalFilename;
  composeFields.to = '"Addressbooks Synchronizer"'; //de.ggbs.abs.gIdty.email; //needed, if doing encryption
//  composeFields.from = 'Addressbooks Synchronizer'; // does not work (automatically overridden) :-(
  composeFields.fcc = de.ggbs.abs.gABS.imapfolder; // else a 'FCC: imap://ggbs@mailhost.iwf.ing.tu-bs.de/INBOX/sent' appears
  composeFields.body = 'Addressbooks Synchronizer: '+externalFilename+'\nDo not delete this message!!!\n';

  composeFields.messageId = de.ggbs.abs.getMsgId(externalFilename);

  var attachment = Components.classes["@mozilla.org/messengercompose/attachment;1"].
    createInstance(Components.interfaces.nsIMsgAttachment);
  var addrbook=de.ggbs.abs.gABS.getAddressBook(mabFile);
  var directoryService =  Services.dirsvc;
  var profileFolder = directoryService.get('ProfD',  Components.interfaces.nsIFile);
  var profileDir = profileFolder.QueryInterface(Components.interfaces.nsILocalFile);
  var nsIMabFile = profileDir.clone().QueryInterface(Components.interfaces.nsILocalFile);
  nsIMabFile.appendRelativePath( addrbook.fileName );
  attachment.url = 'file://'+nsIMabFile.path;
  attachment.name = externalFilename;
  composeFields.addAttachment(attachment);
  var lmt=new Date(nsIMabFile.lastModifiedTime);
  composeFields.cc = lmt;
  composeFields.otherRandomHeaders = "X-LastModifiedTime: "+lmt+'\r\n';
//TODO: the timestamp inside the mabfile is incorrect, since not updated here!

  composeFields.bodyIsAsciiOnly = true;
  composeFields.forcePlainText  = true;
  composeFields.attachVCard   = false;
dump('ABS: IMAP: ViaDraft: composeFields set\n');

  var sMsgComposeService = MailServices.compose;
  if (sMsgComposeService)
  {
dump('ABS: IMAP: ViaDraft: have sMsgComposeService\n');
    var msgCompose = sMsgComposeService.initCompose(params);
    if (msgCompose)
    {
dump('ABS: IMAP: ViaDraft: have msgCompose\n');
      de.ggbs.abs.statustxt(".", 0, false); // 2. dot: InitCompose done
      stateListener.msgCompose = msgCompose;
      msgCompose.RegisterStateListener(stateListener);
        // .Save, .SaveAs und .Now does not work (Upload window verschwindet,
        //   aber immer noch up/download in Progress und kein Fehler in JavaScriptConsole
        // Mit .Now ist die message tatsächlich verschickt worden :-)
        // Mit .Later landet es in LocalFolders.unsent und will später versendet werden.
      msgCompose.SendMsg(Components.interfaces.nsIMsgCompDeliverMode.SaveAsDraft,
        de.ggbs.abs.gIdty, de.ggbs.abs.gAccount.key, null, null);
      de.ggbs.abs.statustxt(".", 0, false); // 3. dot: SendMsg done
    }
else dump('ABS: IMAP: ViaDraft: no msgCompose\n');
  }
else dump('ABS: IMAP: ViaDraft: no sMsgComposeService\n');

  return;
}

///////////////////////////////////////////////////////////////////////////
de.ggbs.abs.saveViaFile=function(externalFilename, mabName, mabFile, deleteMsgs) {
  var b64Name=btoa(unescape(encodeURIComponent(externalFilename)));  // base64 encode the filename
  var eb64Name='=?UTF-8?b?'+b64Name+'?=';
  var time=Date.now();

  var nsIMabFile=de.ggbs.abs.gABS.getDir('ProfD');
  nsIMabFile.appendRelativePath( mabFile );
  var abData=de.ggbs.abs.gABS.readMabData(nsIMabFile, false);
  if (!abData) {
    de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied'), 2, true);
    de.ggbs.abs.imapSaveNextBook();
    return;
  }
  de.ggbs.abs.statustxt(".", 0, false); // 2. dot: mab data loaded

  var header='';
  header+='Message-ID: '+de.ggbs.abs.getMsgId(externalFilename)+'\r\n';
  header+='Date: '+Date(time)+'\r\n';
  header+='From: '+de.ggbs.abs.gIdty.email+'\r\n';
  header+='To: "Addressbooks Synchronizer"\r\n';
  header+='Subject: Addressbooks Synchronizer: '+eb64Name+'\r\n';
  var lmt=new Date(nsIMabFile.lastModifiedTime);
  header+='CC: '+lmt+'\r\n';
  header+='X-LastModifiedTime: '+lmt+'\r\n';
  header+='Content-Type: multipart/mixed; boundary="------------'+time+'"\r\n';
  header+='\r\n';
  header+='This is a multi-part message in MIME format.\r\n';
  header+='--------------'+time+'\r\n';
  header+='Content-Type: text/plain; charset=UTF-8\r\n';
  header+='Content-Transfer-Encoding: 8bit\r\n';
  header+='\r\n';
  header+='Addressbooks Synchronizer: '+unescape(encodeURIComponent(externalFilename))+'\r\n';
  header+='Do not delete this message!!!\r\n';
  header+='\r\n';
  header+='--------------'+time+'\r\n';
  header+='Content-Type: text/plain; name="'+eb64Name+'"\r\n';
  header+='Content-Transfer-Encoding: 7bit\r\n';
  header+='Content-Disposition: inline; filename="='+eb64Name+'"\r\n';
  header+='\r\n';

  var tailer='';
  tailer+='\r\n';
  tailer+='--------------'+time+'\r\n';

  var nsITmpFile=de.ggbs.abs.gABS.getDir('TmpD');
  nsITmpFile.appendRelativePath(de.ggbs.abs.gTempName);
  if (!de.ggbs.abs.gABS.writeMabData(nsITmpFile, header+abData+tailer)) {
    de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied'), 2, true);
    de.ggbs.abs.imapSaveNextBook();
    return;
  }
  de.ggbs.abs.statustxt(".", 0, false); // 3. dot: tmp file written
dump('ABS: IMAP: ViaFile: Tempfile written '+nsITmpFile.path+'\n');

  var deleteMsgsCount=deleteMsgs.Count();
  var fileSpec = nsITmpFile;
  var havefilespec=false;
  var dm=Components.classes["@mozilla.org/array;1"].
      createInstance(Components.interfaces.nsIMutableArray);
  for (var i=0; i<deleteMsgsCount; i++)
    dm.appendElement(deleteMsgs.GetElementAt(i), false);
  deleteMsgs=dm;
dump('ABS: IMAP: ViaFile: no filespec, convert deleteMsgs\n');
dump('ABS: IMAP: ViaFile: checked for filespec\n');

  // listen for the end of a 'store to imap folder'
  var copyServiceListener = {
      QueryInterface: function(iid) {
//dump('ABS: IMAP: ViaFile: QueryInterface called\n');
        if (iid.equals(Components.interfaces.nsIMsgCopyServiceListener) ||
            iid.equals(Components.interfaces.nsISupports))
          return this;
        throw Components.results.NS_NOINTERFACE;
        return 0;
      },

      OnProgress:  function(progress, progressMax) {
//dump('ABS: IMAP: ViaFile: OnProgress called: '+progress+' '+progressMax+'\n');
        // never called!!
      },

      OnStartCopy: function() {
dump('ABS: IMAP: ViaFile: OnStartCopy called\n');
//dump('de='+de+'\n');
      },

      OnStopCopy:  function(status) {
dump('ABS: IMAP: ViaFile: OnStopCopy called: status='+status+'\n');
//dump('de='+de+'\n');

        //Beim upload at onUnload ohne popupfenster
        //  existiert hier de.ggbs.abs.statustxt() und auch z.B. alert() nicht mehr
        try { de.ggbs.abs.statustxt; }
        catch(e) { window.close; return; } //thunderbird hängt!

        if (!status) {          // store has finished
          de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('copied'), 2, false);
        } else {
          de.ggbs.abs.statustxt(de.ggbs.abs.errorstr(status), 2, true);
        }
        //deleteMsgs is nsISupportsArray, SeaMonkey needs nsIArray
        if (deleteMsgsCount>0)
          de.ggbs.abs.gImapFolder.deleteMessages ( deleteMsgs, null, true, false, null, false);
        if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.imapSaveNextBook, 100);
        else de.ggbs.abs.imapSaveNextBook();
      },

      SetMessageKey:  function(key) {
dump('ABS: IMAP: ViaFile: SetMessageKey called: key='+key+'\n');
        de.ggbs.abs.statustxt(".", 0, false); // 4. dot: uploaded to server done
        // will not be called, if message not copied to server
        // will probably not called if server delivers no message key!?
      }
  }

  // with de.ggbs.abs.gImapFolder.copyFileMessage, onStartCopy and onStopCopy gets not called!!
  var gMessageService = MailServices.copy;
  var READ=1; //see mailnews\base\public\nsMsgMessageFlags.idl
  gMessageService.CopyFileMessage(fileSpec, de.ggbs.abs.gImapFolder, null, false, READ,
      '', copyServiceListener, null);

  // next mabfile is started, when listener is informed about the end of the operation
dump('ABS: IMAP: ViaFile: return from saveViaFile\n');
  return;
}

/////////////////////////////////////////////////////////////////////////

de.ggbs.abs.getMsgId=function(theName) {
  return encodeURI(theName+'@AddressBooksSynchronizer');
}
